/*
******************************************************************************

   OVL implementation for X target - header.

   Copyright (C) 2001	Christoph Egger	[Christoph_Egger@t-online.de]

   Permission is hereby granted, free of charge, to any person obtaining a
   copy of this software and associated documentation files (the "Software"),
   to deal in the Software without restriction, including without limitation
   the rights to use, copy, modify, merge, publish, distribute, sublicense,
   and/or sell copies of the Software, and to permit persons to whom the
   Software is furnished to do so, subject to the following conditions:

   The above copyright notice and this permission notice shall be included in
   all copies or substantial portions of the Software.

   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
   IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
   THE AUTHOR(S) BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
   IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
   CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

******************************************************************************
*/

#include <ggi/internal/ovl.h>
#include <ggi/internal/ovl_debug.h>
#include <ggi/display/x_galloc.h>


/*
 *	 internal stuff
 */
int setdb(ggiOvl_t ovl, void *buf);
int getdb(ggiOvl_t ovl, void *buf);

int setmem(ggiOvl_t ovl, void *buf);
int getmem(ggiOvl_t ovl, void *buf);


/* sprite */
int sprite_show(ggiOvl_t ovl);
int sprite_hide(ggiOvl_t ovl);



/*
 *	"exported" Function prototypes
 */
OvlTie		OVL_X_tie;

OvlSetImage	OVL_X_setimage;
OvlSetPos	OVL_X_setpos;
OvlMove		OVL_X_move;

OvlSetSize	OVL_X_setsize;
OvlSetPriority	OVL_X_setpriority;
OvlSetFlags	OVL_X_setflags;

OvlSetZoom	OVL_X_setzoom;

OvlShow		OVL_X_show;
OvlHide		OVL_X_hide;

OvlEnable	OVL_X_enable;
OvlDisable	OVL_X_disable;



/* Structure holding private data.
 */
struct xovl_priv {
	void *dummy;
};

#define XOVL_PRIV(vis) ((struct xovl_priv *)(LIBGGI_OVLEXT(vis)->priv))




struct xovl_Sprite {
	struct GA_x_sprite *sprite;
};

struct xovl_Window {
	struct GA_x_window *window;
};

struct xovl_Video {
	struct GA_x_video *video;
};


#define GETSPRITE(ovl)	((struct xovl_Sprite *)(ovl->Ovltype.sprite.target))->sprite
#define GETWINDOW(ovl)	((struct xovl_Window *)(ovl->Ovltype.window.target))->window
#define GETVIDEO(ovl)	((struct xovl_Video *)(ovl->Ovltype.video.target))->video

